﻿/* 
    PASS Virtual Group Global Portuguese
    SQL Curiosities: A Curiosidade Matou O Gato
    2017-04-18 (version 1.01)
    Demo - Big cats
    André Melancia
    http://Andy.PT

    (C) 2016-2017, André Melancia


            .                .                    
             :"-.          .-";                    
             |:`.`.__..__.'.';|                    
             || :-"      "-; ||                    
             :;              :;                    
             /  .==.    .==.  \                    
            :      _.--._      ;                   
            ; .--.' `--' `.--. :                   
           :   __;`      ':__   ;                  
           ;  '  '-._:;_.-'  '  :                  
           '.       `--'       .'                  
            ."-._          _.-".                   
          .'     ""------""     `.                 
         /`-                    -'\                
        /`-                      -'\               
       :`-   .'              `.   -';              
       ;    /                  \    :              
      :    :                    ;    ;             
      ;    ;                    :    :             
      ':_:.'                    '.;_;'             
         :_                      _;                
         ; "-._                -" :`-.     _.._    
         :_          ()          _;   "--::__. `.  
          \"-                  -"/`._           :  
         .-"-.                 -"-.  ""--..____.'  
        /         .__  __.         \               
       : / ,       / "" \       . \ ; bug          
        "-:___..--"      "--..___;-"    


*/


--  +----------------------------------------------------------------+
--  | FELINE TASKS                                                   |
--  +----------------------------------------------------------------+

    -- WARNING: Run these scripts on an EMPTY database!

    -- INSTRUCTIONS: Run one statement at a time.
    

--  +----------------------------------------------------------------+
--  | Sharpening the claws                                           |
--  +----------------------------------------------------------------+

    USE PUSSYCAT;           -- Or whatever database you created!
                            -- Please don't run this on the Master, that's
                            -- just ugly!
    GO


    -- Altoug they usually have 9 lives, we're going to kill them faster...
	-- Note: "IF EXISTS" are ugly. First time these will generate errors
    --       Just accept the errors as part of a 9-lives feline's living ;)
	DROP TABLE dbo.BigCats;
	GO

	DROP TABLE dbo.HugeCats;
	GO

	
--  +----------------------------------------------------------------+
--  | Big cats                                                       |
--  +----------------------------------------------------------------+

    -- First let's create a big cat table
    CREATE TABLE dbo.BigCats
	(
	    CatID    BIGINT NOT NULL IDENTITY (1,1),
	    CatStuff INT        NULL
	);
	GO

	-- Now create a HUGE cat table
    CREATE TABLE dbo.HugeCats
	(
	    CatID    BIGINT NOT NULL IDENTITY (1,1),
	    CatStuff INT        NULL
	);
	GO



    -- Then add some values into BigCats (1000)
    INSERT INTO dbo.BigCats (CatStuff) VALUES (NULL);
    GO 1000

	-- Count them!
    SELECT 'BigCats' AS TableName, Min(CatID) AS MinID, Max(CatID) AS MaxID, Count(*) AS CountID FROM BigCats;
    GO



    -- Now add a lot to HugeCats (1000*1000)
    INSERT INTO dbo.HugeCats (CatStuff)
	SELECT NULL FROM BigCats AS x, BigCats as y;
	
	-- Count them now!
    SELECT 'HugeCats' AS TableName, Min(CatID) AS MinID, Max(CatID) AS MaxID, Count(*) AS CountID FROM HugeCats;
    GO




    -- Get results when cross joined (1000000*1000)
    SELECT 'BigCats * HugeCats' AS TableName, Min(z.CatID) AS MinID, Max(z.CatID) AS MaxID, Count(*) AS CountID 
	FROM (SELECT x.CatID FROM HugeCats AS x, BigCats as y) AS z;
	GO

  
    -- Now repeat inserts for BigCats (now 3000 there)
    INSERT INTO dbo.BigCats (CatStuff) VALUES (NULL);
    GO 2000


    -- Get results when cross joined (1000000*3000)
    SELECT 'BigCats * HugeCats' AS TableName, Min(z.CatID) AS MinID, Max(z.CatID) AS MaxID, Count(*) AS CountID
	FROM (SELECT x.CatID FROM HugeCats AS x, BigCats as y) AS z;
	GO


    -- Get results when cross joined (1000000*3000) -- "SMALL" CHANGE
    SELECT 'BigCats * HugeCats (BIG)' AS TableName, Min(z.CatID) AS MinID, Max(z.CatID) AS MaxID, Count_BIG(*) AS CountID
	FROM (SELECT x.CatID FROM HugeCats AS x, BigCats as y) AS z;
	GO


	-- Also...
	-- Instead of @@ROWCOUNT, use ROWCOUNT_BIG()
	-- DATEDIFF_BIG


--  +----------------------------------------------------------------+
--  | Playtime is over.                                              |
--  | Now it's time for a cat nap!                                   |
--  +----------------------------------------------------------------+
