﻿/* 
    PASS Virtual Group Global Portuguese
    SQL Curiosities: A Curiosidade Matou O Gato
    2017-04-18 (version 1.01)
    Demo - Cat Limits
    André Melancia
    http://Andy.PT

    (C) 2016-2017, André Melancia


     /\-/\
     /a a  \                                 _
    =\ Y  =/-~~~~~~-,_______________________/ )
      '^--'          ________________________/
        \           /
        ||  |---'\  \   
  jgs  (_(__|   ((__|   



*/


--  +----------------------------------------------------------------+
--  | FELINE TASKS                                                   |
--  +----------------------------------------------------------------+

    -- WARNING: Run these scripts on an EMPTY database!

    -- INSTRUCTIONS: Run one statement at a time.
    

--  +----------------------------------------------------------------+
--  | Sharpening the claws                                           |
--  +----------------------------------------------------------------+

    USE PUSSYCAT_OLD;       -- Or whatever database you created!
                            -- Please don't run this on the Master, that's
                            -- just ugly!
    GO


    -- Altoug they usually have 9 lives, we're going to kill them faster...
	-- Note: "IF EXISTS" are ugly. First time these will generate errors
    --       Just accept the errors as part of a 9-lives feline's living ;)
	DROP TABLE dbo.CatLimits;
	GO


	
--  +----------------------------------------------------------------+
--  | Cat limits                                                     |
--  +----------------------------------------------------------------+

    -- First let's create a cat table
    CREATE TABLE dbo.CatLimits
	(
	    CatID     BIGINT        NOT NULL IDENTITY (1,1),
	    CatStuff1 CHAR(8000) NOT NULL,
	    CatStuff2 CHAR(8000) NOT NULL,
	);
	GO


--  +----------------------------------------------------------------+
--  | Better Cat limits                                              |
--  +----------------------------------------------------------------+

    -- Doesn't seem to work... Let's try VARCHAR
    CREATE TABLE dbo.CatLimits
	(
	    CatID     BIGINT        NOT NULL IDENTITY (1,1),
	    CatStuff1 VARCHAR(8000) NOT NULL,
	    CatStuff2 VARCHAR(8000) NOT NULL,
	);
	GO




	-- [BLOCK START]
	DECLARE @Stuff_10   VARCHAR(8000)
	DECLARE @Stuff_100  VARCHAR(8000)
	DECLARE @Stuff_1000 VARCHAR(8000)
	DECLARE @Stuff_7000 VARCHAR(8000)
	
	SET @Stuff_10   = '[0010Char]';
	SET @Stuff_100  = '[0100Char]' + REPLICATE ('[23456789]',   9);
	SET @Stuff_1000 = '[1000Char]' + REPLICATE ('[23456789]',  99);
	SET @Stuff_7000 = '[7000Char]' + REPLICATE ('[23456789]', 699);

	SELECT LEN(@Stuff_10)   AS LenStuff_10, 
	       LEN(@Stuff_100)  AS LenStuff_100, 
		   LEN(@Stuff_1000) AS LenStuff_1000, 
		   LEN(@Stuff_7000) AS LenStuff_7000;

    -- Then add some values 
    INSERT INTO dbo.CatLimits (CatStuff1, CatStuff2) VALUES (@Stuff_10,   'No Cats Here');
    INSERT INTO dbo.CatLimits (CatStuff1, CatStuff2) VALUES (@Stuff_100,  'No Cats Here');
    INSERT INTO dbo.CatLimits (CatStuff1, CatStuff2) VALUES (@Stuff_1000, 'No Cats Here');
    INSERT INTO dbo.CatLimits (CatStuff1, CatStuff2) VALUES (@Stuff_7000, 'No Cats Here');
    INSERT INTO dbo.CatLimits (CatStuff1, CatStuff2) VALUES (@Stuff_7000, 'OtherInfo' + @Stuff_7000);
	-- [BLOCK END]



	-- Now let's see them
    SELECT LEN(CatStuff1) As LenStuff1,
	       LEN(CatStuff2) As LenStuff2, 
		   CatStuff1, 
		   CatStuff2         
    FROM dbo.CatLimits;


    
	-- Now the fields joined
	SELECT LEN(CatStuff1) + LEN(CatStuff2) As LenStuffBoth,
	       CatStuff1 + CatStuff2 AS StuffBoth 
    FROM dbo.CatLimits;



	-- Now the fields joined with VARCHAR(MAX)
	SELECT LEN(CatStuff1) + LEN(CatStuff2) As LenStuffBoth,
	       CONVERT(VARCHAR(MAX), CatStuff1) + CONVERT(VARCHAR(MAX), CatStuff2) AS StuffBoth 
    FROM dbo.CatLimits;


--  +----------------------------------------------------------------+
--  | Playtime is over.                                              |
--  | Now it's time for a cat nap!                                   |
--  +----------------------------------------------------------------+
